/*
Alban Francesco

Questa classe implementa l'algoritmo di scheduling FCFS	
*/
package classFile;
public class Fifo
{	
	//costruttore vuoto
	public Fifo(){}
	/*
		metodo per trovare quale processo mandare in esecuzione.
		Controlla i processi arrivati al tempo tar con tempo di computazione >0
		e manda in esecuzione quello arrivato prima.
		La variabile ta serve per prendere il tempo di arrivo minore.		
	*/
	public static int trovaMin(Processo[] p,int n,double tar)
	{
		double ta=100000;
		int min=10000;
		for(int i=0;i<n;i++)
		{					
				if ((p[i].getTa()<=tar)&&(p[i].getTc()>0)&&(p[i].getTa()<ta))
				{
					ta=p[i].getTa();
					min=i;
				}			
		}			
		return min;
	}
	//metodo per la schedulazione, ritorna un oggetto di tipo stat
	public stat schedulaFifo(Processo[] p,int n)
	{		
		double tempo=0;
		//dichiaro e inizializzo il vettore attesa
		double []attesa=new double[n];
		for(int i=0;i<n;i++)
			attesa[i]=0.0;
		//calcolo il tempo
		for(int i=0;i<n;i++)
			tempo+=p[i].getTc();
		int min;
		//trovo il processo da mandare in esecuzione al tempo 0		
		min=trovaMin(p,n,0);
		double i=0;
		//dichiaro e inizializzo i vettori partenza e fine
		double []fine=new double[n];
		double []partenza=new double[n];
		for(int o=0;o<n;o++)
		{
			fine[o]=0;
			partenza[o]=-1;
		}			
		while (i<tempo)
		{
			//salvo il tempo di partenza di ogni processo
			if (partenza[min]==-1)
				partenza[min]=i;
			double app=p[min].getTc();
			//incremento i del valore pari al tempo di computazione del processo appena eseguito
			i=i+app;						
			p[min].setTc(p[min].getTc()-app);
			//salvo il tempo di fine di ogni processo
			fine[min]=i;
			//trovo il nuovo processo da mandare in esecuzione al tempo i
			min=trovaMin(p,n,i);
		}
		for(int j=0;j<n;j++)
		{
			//calcolo i valori del tempo di attesa per ogni processo
			attesa[j]=fine[j]-p[j].getTcIniz()-p[j].getTa();
		}
		/*
			Creo un oggetto di tipo calcolo per calcolare le statistiche e salvo un oggetto di tipo stat
			che contiene tutti questi valori
		*/		
		Calcolo c=new Calcolo(partenza,fine,n);
		stat sta=c.calcola(attesa,p);
		return sta;
	}
}
