/*
	Alban Francesco
	
	Classe per la creazione della finestra per l'inserimento dati dei processi
*/
package classFile;
import java.awt.*;
public class FinestraDati
{
	//dichiarazioni delle variabili
	public Button indietro;
	public Frame f1;
	public Choice alg;		
	public TextField []ta;
	public TextField []tc;
	public TextField []pr;
	public Label []l;
	public Button schedula;		
	public TextField quanto;
	public Button cancella;
	public FinestraDati()
	{
		//creo la finestra
		f1= new Frame("Finestra Inserimento Dati");
		//creo i bottoni
		indietro=new Button("Indietro");
		schedula=new Button("Schedula");
		cancella=new Button("Cancella");		
		//creo due colori
		Color col=new Color(21,191,101);
		Color coll=new Color(77,249,157);
		//setto il colore di background della finestra e dei bottoni
		f1.setBackground(coll);
		indietro.setBackground(coll);
		schedula.setBackground(coll);
		cancella.setBackground(coll);
		//setto l'"ascoltatore della finestra"
		f1.addWindowListener(new GestoreFinestra());
		//metto la finestra in alto a sinistra		
		f1.setLocation(0,0);
		//setto la dimensione
		f1.setSize(1024,768);
		//setto il layout della finestra a griglia. 14 righe 4 colonne 
		//e gli oggetti distanti 5 pixel l'uno dall'altro
		f1.setLayout(new GridLayout(14,4,5,5));
		//creo una label e metto la scritta al centro
		f1.add(new Label("Scegli l'algoritmo ",Label.CENTER));
		//menu a tendina
		alg=new Choice();
		alg.setBackground(coll);
		//aggiungo gli elementi al menu a tendina
		alg.addItem("FCFS");
		alg.addItem("SJF NON PREEMPTIVE");
		alg.addItem("SJF PREEMPTIVE");
		alg.addItem("PRIORITA' NON PREEMPTIVE");
		alg.addItem("PRIORITA' PREEMPTIVE");
		alg.addItem("HRRN NON PREEMPTIVE");
		alg.addItem("ROUND ROBIN ATTESA");
		alg.addItem("ROUND ROBIN RISPOSTA");
		//aggiungo alla finestra il menu a tendina		
		f1.add(alg);
		//pongo la finestra non ridimensionabile e invisibile
		f1.setResizable(false);
		f1.setVisible(false);
		//aggiungo alla finestra gli altri elementi
		f1.add(indietro);
		f1.add(schedula);
		f1.add(new Label("Processo numero",Label.CENTER));			
		f1.add(new Label("Tempo di arrivo",Label.CENTER));
		f1.add(new Label("Tempo di computazione",Label.CENTER));
		f1.add(new Label("Priorita'",Label.CENTER));
		//creo 3 array di caselle di testo: una per il tempo di arrivo, una per il tempo di computazione
		//e una per la priorita'
		ta=new TextField[10];
		tc=new TextField[10];
		pr=new TextField[10];
		l=new Label[10];		
		for(int i=0;i<10;i++)
		{
			//salvo in una stringa il numero del processo e aggiungo 1 per partire a contare da 1
			String s=String.valueOf(i+1);
			//creo la label con il valore salvato
			l[i]=new Label(s,Label.CENTER);
			//aggiungo la label
			f1.add(l[i]);
			//creo gli oggetti caselle di testo
			ta[i]=new TextField(5);
			ta[i].setBackground(col);
			tc[i]=new TextField(5);
			tc[i].setBackground(col);
			pr[i]=new TextField(5);
			pr[i].setBackground(col);
			//li aggiungo alla finestra
			f1.add(ta[i]);					
			f1.add(tc[i]);
			f1.add(pr[i]);
			//rendo sia le etichette che le caselle di testo invisibili
			//li rendero' visibili in un secondo momento quando sapro'
			//il numero di processi desiderati
			l[i].setVisible(false);
			ta[i].setVisible(false);
			tc[i].setVisible(false);
			pr[i].setVisible(false);	
		}
		//creo l'etichetta e la casella di testo per il valore del quanto		
		f1.add(new Label("Quanto",Label.CENTER));
		quanto=new TextField(5);
		quanto.setBackground(col);
		f1.add(quanto);
		//aggiungo una label vuota per rispettare gli spazi del layout a griglia
		f1.add(new Label());
		f1.add(cancella);
	}
}
