/*
	Alban Francesco
	
	Classe per la gestione di tutti i tasti prensenti nelle finestre.
	Questa classe e' il "cuore" dell'interfaccia grafica.
*/
package classFile;
import java.awt.event.*;
import java.awt.*;
import java.awt.Graphics;
import java.awt.Color;
import java.lang.Math;
import java.math.BigDecimal;
//estendo Canvas per il disegno e implemento ActionListener per la gestione degli eventi dei bottoni
class GestoreBottone extends Canvas implements ActionListener
{
	//dichiarazioni di tutte la variabili utilizzate in questa classe
	//per coerenza ho mantenuto i nomi utilizzati nelle altri classi 
	private Frame f,f1,f2;
	//deve essere per forza pubblica perche' utilizzata in un'altra classe
	public Frame f3;
	private Choice nprocessi;
	private Choice alg;
	private TextField []ta;
	private TextField []tc;	
	private TextField []pr;	
	private Label []l;
	private Label []ll;
	private Label []lll;
	private TextField []tat;
	private TextField []trisp;	
	private TextField []turn;
	private TextField quanto;
	private TextField trispm,tatm,turnm;
	private static int tipo;
	private Color col=new Color(21,191,101);
	private static double []part=new double[10];
	private static double []fine=new double[10];
	private static int np;	
	private static double tempo=0;
	private static double intervallo=0;
	private static double []esecuzione;
	private static int ok=1;
	private static double []temp=new double[10];
	//costruttore utilizzato in finestra grafico
	public GestoreBottone(Frame f3){this.f3=f3;}
	//costruttore principale dove passo tutti i valori di tutte le finestre (per comodita')		
	public GestoreBottone(FinestraPrincipale fp,FinestraDati fd,FinestraGrafico fg,FinestraRisultati fr)
	{
		this.f=fp.f;
		this.f1=fd.f1;		
		this.f2=fr.f2;
		this.f3=fg.f3;		
		this.ta=fd.ta;
		this.tc=fd.tc;
		this.pr=fd.pr;
		this.alg=fd.alg;
		this.nprocessi=fp.nprocessi;
		this.tat=fr.tat;
		this.trisp=fr.trisp;
		this.turn=fr.turn;
		this.ll=fr.ll;
		this.l=fd.l;
		this.lll=fg.lll;
		this.quanto=fd.quanto;
		this.tatm=fr.tatm;
		this.trispm=fr.trispm;
		this.turnm=fr.turnm;
		
	}
	//metodo che disegna il grafico
	public void paint(Graphics g)
	{			
		
		if(tipo==-1)
		{
			//situazione iniziale. Non disegno nulla	
		}
		else
		{
			//creo un rettangolo (posX,posY,larghezza,altezza)
			g.drawRect(10,20,970,20);			
			BigDecimal bg;
			bg=new BigDecimal(tempo);
			//arrotondo il valore del tempo 
			//se l'algoritmo non e' preemptive a 2 cifre decimali
			if (tipo==0)
				bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
			//se l'algoritmo e' preemptive a 1 cifra decimale (per evitare sporcature come 10.000000000001)
			if(tipo==1)
				bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
			tempo=bg.doubleValue();
			//scrivo il valore del tempo alla fine del grafico, in basso o in alto in base al numero dei processi
			if(np%2==0)
				g.drawString(String.valueOf(tempo),980,51);
			else
				g.drawString(String.valueOf(tempo),980,18);		
			//disegno per l'algoritmo non preemptive
			if(tipo==0)
			{								
				long app,app2;
				for(int i=0;i<np;i++)
				{					
					//setto il colore nero (per le scritte)
					g.setColor(Color.black);
					//arrotondo il valore della partenza a 2 cifre decimali
					bg=new BigDecimal(part[i]);
					bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
					part[i]=bg.doubleValue();
					//calcolo e arrotondo il valore di temp+10
					//(aggiungo 10 perche' il disegno e' spostato di 10 pixel)
					app=Math.round(temp[i]+10);
					//calcolo l'ampiezza
					app2=Math.round(fine[i]-temp[i]);
					//scrivo il numero della partenza cercando un'alternanza basso-alto
					if(part[i]==0)
						g.drawString(String.valueOf(part[i]),(int)app,51);
					else if (i%2==0)
						g.drawString(String.valueOf(part[i]),(int)app,51);
					else
						g.drawString(String.valueOf(part[i]),(int)app,18);
					
					//in base al numero del processo ho un colore 
					//ovviamente uguali ai colori delle label in finestra grafico
					if(i==0)
						g.setColor(Color.black);
					if(i==1)
						g.setColor(Color.yellow);
					if(i==2)
						g.setColor(Color.green);
					if(i==3)
						g.setColor(Color.cyan);
					if(i==4)
						g.setColor(Color.pink);
					if(i==5)
						g.setColor(Color.red);
					if(i==6)
						g.setColor(Color.blue);
					if(i==7)
						g.setColor(Color.orange);
					if(i==8)
						g.setColor(Color.gray);
					if(i==9)
						g.setColor(Color.white);
					//riempio il rettangolo (x,y,larghezza,altezza)
					g.fillRect((int)app,20,(int)app2,20);					
				}					
			}
			//disegno preemptive
			if(tipo==1)				
			{				
				//variabile per l'alternanza della scritta in basso/alto
				int basso=0;
				//scrivo il numero 0.0
				g.drawString("0.0",10,18);
				//i deve essere double per fare la divisione
				for(double i=0;i<(int)(tempo*10);i++)
				{
					//setto il colore nero per le stringhe
					g.setColor(Color.black);
					//se il tempo non e' al max e il vettore esecuzione in pos i e' diverso dal pos i+1
					//significa che ho avuto un cambio del processo in esecuzione e allora scrivo il tempo
					if((i!=((tempo*10)-1))&&(esecuzione[(int)i]!=esecuzione[(int)i+1]))
					{
						bg=new BigDecimal((i+1)/10);
						bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);						
						if (basso==0)
						{
							g.drawString(String.valueOf(bg.doubleValue()),(int)((i+1)*intervallo)+10,51);				
							basso=1;
						}
						else
						{	
							g.drawString(String.valueOf(bg.doubleValue()),(int)((i+1)*intervallo)+10,18);
							basso=0;
						}
					}	
					//un colore per ogni processo				
					if(esecuzione[(int)i]==0)
						g.setColor(Color.black);
					if(esecuzione[(int)i]==1)
						g.setColor(Color.yellow);
					if(esecuzione[(int)i]==2)
						g.setColor(Color.green);
					if(esecuzione[(int)i]==3)
						g.setColor(Color.cyan);
					if(esecuzione[(int)i]==4)
						g.setColor(Color.pink);
					if(esecuzione[(int)i]==5)
						g.setColor(Color.red);
					if(esecuzione[(int)i]==6)
						g.setColor(Color.blue);
					if(esecuzione[(int)i]==7)
						g.setColor(Color.orange);
					if(esecuzione[(int)i]==8)
						g.setColor(Color.gray);
					if(esecuzione[(int)i]==9)
						g.setColor(Color.white);
					//calcolo la posizione di partenza per colorare 					
					double app2=i*intervallo+10;
					//riempio il rettangolo partendo da app2 e coloro di uno spazio pari all'intervallo
					g.fillRect((int)app2,20,(int)(Math.ceil(intervallo)),20);
					
				}
			}	
		}
	}	
	//metodo per la gestione dei bottoni
	public void actionPerformed(ActionEvent e)
	{		 
		//salvo la stringa corrispondente al caption del bottone (non al suo nome)
		String bottone=e.getActionCommand();		
		//creo un oggetto gestore bottone per il disegno 
		//f3 corrisponde al frame di finestra grafico
		GestoreBottone gb=new GestoreBottone(f3);	
		//se il caption del bottone e' uguale a "xxx" eseguo le operazioni tra graffe
		/*
			f -> frame di finestra principale (quella iniziale)
			f1-> frame di finestra dati
			f2 -> frame di finestra risultati (statistiche) 
			f3 -> frame della finestra grafico
			
			in base al bottone premuto rendo visibile una finestra alla volta
			le altre le rendo invisibili			
		*/
		if (bottone.equals("Visualizza grafico"))
		{
			f.setVisible(false);			
			f1.setVisible(false);
			f2.setVisible(false);
			f3.setVisible(true);
		}	
		if (bottone.equals("Cambia algoritmo"))
		{
			f2.setVisible(false);
			f.setVisible(false);
			f1.setVisible(true);
			f3.setVisible(false);
		}
		if (bottone.equals("Cambia numero processi"))
		{
			f2.setVisible(false);
			f.setVisible(true);
			f1.setVisible(false);
			f3.setVisible(false);
		}
		if (bottone.equals("Statistiche processi"))
		{
			f2.setVisible(true);
			f.setVisible(false);
			f1.setVisible(false);
			f3.setVisible(false);
		}
		if (bottone.equals("Avanti"))
		{
			f.setVisible(false);
			f1.setVisible(true);
			f2.setVisible(false);
			f3.setVisible(false);
			/*
				in base al numero dei processi setto la variabile np al numero corrispondente
				e tramite ciclo for rendo visibili in tutte le finestre solamente le caselle di
				testo e le etichette pari al numero di processi selezionati
			*/
			//comando per "prendere" il valore selezionato con il menu a tendina
			switch(nprocessi.getSelectedIndex())
			{
			case 0: 
			{
				np=2;
				for(int i=0;i<2;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
					
				}
				break;
			}
			case 1:
			{
				np=3;
				for(int i=0;i<3;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			case 2:
			{		
				np=4;
				for(int i=0;i<4;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			case 3:	
			{				
				np=5;
				for(int i=0;i<5;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}		
			case 4:
			{				
				np=6;
				for(int i=0;i<6;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			case 5:
			{
				np=7;
				for(int i=0;i<7;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			case 6:
			{
				np=8;
				for(int i=0;i<8;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			case 7:
			{
				np=9;
				for(int i=0;i<9;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			case 8:
			{
				np=10;
				for(int i=0;i<10;i++)
				{
					l[i].setVisible(true);
					ta[i].setVisible(true);
					tc[i].setVisible(true);
					pr[i].setVisible(true);
					ll[i].setVisible(true);
					tat[i].setVisible(true);
					trisp[i].setVisible(true);
					turn[i].setVisible(true);
					lll[i].setVisible(true);
				}
				break;
			}
			}
		}
		if (bottone.equals("Indietro"))
		{			
			/*
				tramite questo tasto rendo invisibili tutte le etichette e caselle
				di testo
			*/
			for(int i=0;i<10;i++)
			{
				l[i].setVisible(false);
				ta[i].setVisible(false);
				tc[i].setVisible(false);
				pr[i].setVisible(false);
				ll[i].setVisible(false);
				tat[i].setVisible(false);
				trisp[i].setVisible(false);
				turn[i].setVisible(false);
				lll[i].setVisible(false);				
				ta[i].setBackground(col);
				tc[i].setBackground(col);
				pr[i].setBackground(col);				
			}
			//ripristo il valore iniziale di ok
			ok=1;
			f1.setVisible(false);
			f.setVisible(true);
			f2.setVisible(false);
			f3.setVisible(false);
		}
		if(bottone.equals("Cancella"))
		{
			//pulisco tutte le caselle di testo presenti in finestra dati
			for(int i=0;i<10;i++)
			{	
				ta[i].setText("");
				tc[i].setText("");
				pr[i].setText("");
			}
			quanto.setText("");
			ok=1;
		}
		if(bottone.equals("Schedula"))
		{
			/*
				Gestione del pulsante schedula.
				In base alla scelta fatta con il menu a tendina verra'
				utilizzato l'algoritmo di scheduling scelto
			*/
			f.setVisible(false);
			//ripristino il valore di ok
			ok=1;
			//creo un oggetto BigDecimal per arrotondare e una variabile di appoggio
			BigDecimal bg;
			double app;
			f1.setVisible(false);
			f2.setVisible(false);
			f3.setVisible(true);
			//comando per inserire il grafico in f3
			//verra' inserito un disegno solo quando tipo avra' un valore
			// 0 o 1			
			Graphics grafico  = gb.f3.getGraphics();	
			//creo un array di tipo Processo		
			Processo []proc=new Processo[np];
			//inizializzo la var del tempo a 0
			tempo=0;			
			for(int i=0;i<np;i++)
			{
				//se la casella di testo tempo di arrivo e' vuota o tempo di computazione e' vuota
				if ((ta[i].getText().equals(""))||(tc[i].getText().equals("")))
				{
					//in base a quale delle due e' vuota setto lo sfondo di 
					//queste di colore rosso
					if(ta[i].getText().equals(""))
						ta[i].setBackground(Color.red);
					if(tc[i].getText().equals(""))
						tc[i].setBackground(Color.red);
					f.setVisible(false);
					f1.setVisible(true);
					f2.setVisible(false);
					f3.setVisible(false);
					//pongo ok a zero in modo che successivamente il programma si blocchi
					//questa var e' necessaria perche' se una riga e' riempita in tutti i campi
					//mentre le altre no il programma riusciva ad avanzare
					ok=0;
				}
				//se i campi sono stati tutti riempiti
				else if (ok==1)
				{	
					//ripristino il colore verde
					ta[i].setBackground(col);
					tc[i].setBackground(col);	
					//creo l'oggetto processo prendendo i valori dalle caselle di testo con getText()
					//e trasformo le stringhe in double con doubleValue()								
					proc[i]=new Processo(Double.valueOf(ta[i].getText()).doubleValue(),Double.valueOf(tc[i].getText()).doubleValue());
					//calcolo il tempo
					tempo+=Double.valueOf(tc[i].getText()).doubleValue();
					//ok=1;
				}
			}
			//creo l'array esecuzione
			esecuzione=new double[(int)(tempo*10)];			
			//calcolo l'intervallo dividendo la lunghezza del grafico (970) per il tempo
			intervallo=970/tempo;
			//altre dichiarazioni di variabili
			stat sta;
			double q;
			switch(alg.getSelectedIndex())
			{
				case 0:
				{
					//se i campi sono stati riempiti completamente
					if (ok==1)
					{
						/*
							FCFS
						*/
						//setto il tipo=0 (disegno non preemptive)
						tipo=0;
						//creo l'oggetto di tipo Fifo e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						Fifo fi=new Fifo();
						sta=fi.schedulaFifo(proc,np);
						//ciclo for fino a np (numero processi)
						for(int i=0;i<np;i++)
						{
							/*
								salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
								presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
								alle prime 2 cifre decimali. Poi con setText() li scrivo nelle caselle di testo
								in finestra risultati
							*/
							app=sta.getAttesa(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tat[i].setText(String.valueOf(app));
							app=sta.getRisposta(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trisp[i].setText(String.valueOf(app));
							app=sta.getAround(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turn[i].setText(String.valueOf(app));							
							part[i]=sta.getPartenza(i);
							fine[i]=sta.getFine(i);
						}
						/*
							come prima, ma ora prendo i tempi medi (con 3 cifre dopo la virgola)
						*/
						app=sta.getAttesam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						tatm.setText(String.valueOf(app));
						app=sta.getRispostam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						trispm.setText(String.valueOf(app));
						app=sta.getAroundm();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						turnm.setText(String.valueOf(app));
						/*
							moltiplico i valori di partenza e di fine per l'intervallo
							i valori di part vengono salvati in temp perche' altrimenti nel metodo paint
							avrei dovuto ridividerlo ancora e c'erano problemi di perdita di precisione
						*/
						for(int i=0;i<np;i++)
						{
							temp[i]=part[i]*intervallo;
							fine[i]=fine[i]*intervallo;
							
						}
						//aggiorno il grafico
						gb.update(grafico);
						
					}					
				}
				break;
				case 1:
				{
					//se i campi sono stati riempiti completamente
					if (ok==1)
					{
						/*
							SJF non preemptive
						*/
						//setto il tipo=0 (disegno non preemptive)
						tipo=0;
						//creo l'oggetto di tipo SJF e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						Sjf s=new Sjf();
						//0 corrisponde alla scelta di SJF non preemptive
						sta=s.schedulaSjf(proc,np,0);
						/*
								salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
								presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
								alle prime 2 cifre decimali. Poi con setText() li scrivo nelle caselle di testo
								in finestra risultati
						*/
						for(int i=0;i<np;i++)
						{				
							app=sta.getAttesa(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tat[i].setText(String.valueOf(app));
							app=sta.getRisposta(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trisp[i].setText(String.valueOf(app));
							app=sta.getAround(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turn[i].setText(String.valueOf(app));							
							part[i]=sta.getPartenza(i);
							fine[i]=sta.getFine(i);							
						}
						/*
							come prima, ma ora prendo i tempi medi (con 3 cifre dopo la virgola)
						*/
						app=sta.getAttesam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						tatm.setText(String.valueOf(app));
						app=sta.getRispostam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						trispm.setText(String.valueOf(app));
						app=sta.getAroundm();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						turnm.setText(String.valueOf(app));
						/*
							moltiplico i valori di partenza e di fine per l'intervallo
							i valori di part vengono salvati in temp perche' altrimenti nel metodo paint
							avrei dovuto ridividerlo ancora e c'erano problemi di perdita di precisione
						*/
						for(int i=0;i<np;i++)
						{
							temp[i]=part[i]*intervallo;
							fine[i]=fine[i]*intervallo;							
						}
						//aggiorno il grafico
						gb.update(grafico);
					}					
				}
				break;
				case 2:
				{
					//se i campi sono stati riempiti completamente
					if (ok==1)
					{
						/*
							SJF-preemptive
						*/
						//setto il tipo=1 (disegno preemptive)
						tipo=1;
						//creo l'oggetto di tipo SJF e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						Sjf s=new Sjf();
						//1 corrisponde alla scelta di SJF-preemptive
						sta=s.schedulaSjf(proc,np,1);
						/*
								salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
								presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
								alla prima cifra decimale. Poi con setText() li scrivo nelle caselle di testo
								in finestra risultati
						*/
						for(int i=0;i<np;i++)
						{				
							app=sta.getAttesa(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tat[i].setText(String.valueOf(app));
							app=sta.getRisposta(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trisp[i].setText(String.valueOf(app));
							app=sta.getAround(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turn[i].setText(String.valueOf(app));
						}	
						/*
							come prima, ma ora prendo i tempi medi
						*/			
						app=sta.getAttesam();
						bg=new BigDecimal(app);
						bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						tatm.setText(String.valueOf(app));
						app=sta.getRispostam();
						bg=new BigDecimal(app);
						bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						trispm.setText(String.valueOf(app));
						app=sta.getAroundm();
						bg=new BigDecimal(app);
						bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						turnm.setText(String.valueOf(app));
						//divido l'intervallo per 10 perche' il tempo e' moltiplicato per 10
						intervallo=intervallo/10;
						//prendo dall'oggetto stat il vettore esecuzione						
						for(int i=0;i<(int)(tempo*10);i++)
							esecuzione[i]=sta.getEsecuzione(i);
						//aggiorno il grafico
						gb.update(grafico);
					}					
				}
				break;
				case 3:
				{
					/*
							PRIORITA' non preemptive
					*/
					//setto il tipo=0 (disegno non preemptive)
					tipo=0;
					/*
						rieseguo il controllo fatto in precedenza ma aggiungendo anche i campi
						relativi alla priorita'
					*/
					for(int i=0;i<np;i++)
					{	
						if ((ta[i].getText().equals(""))||(tc[i].getText().equals(""))||(pr[i].getText().equals("")))
						{
							if(ta[i].getText().equals(""))
								ta[i].setBackground(Color.red);
							if(tc[i].getText().equals(""))
								tc[i].setBackground(Color.red);
							//se la casella di testo priorita' e' vuota metto il colore rosso alla casella 
							//di testo corrispondente
							if(pr[i].getText().equals(""))
								pr[i].setBackground(Color.red);
							f.setVisible(false);
							f1.setVisible(true);
							f2.setVisible(false);
							f3.setVisible(false);
							/*
								se almeno un campo e' vuoto pongo ok a 2.
								metto 2 invece di 0 come prima per differenziare i due casi.
							*/
							ok=2;
						}
						//se ok rimane invariato			
						else if (ok==1)
						{
							//ripristino il colore verde
							ta[i].setBackground(col);
							tc[i].setBackground(col);
							pr[i].setBackground(col);
							//creo gli oggetti di tipo Processo
							proc[i]=new Processo(Double.valueOf(ta[i].getText()).doubleValue(),Double.valueOf(tc[i].getText()).doubleValue(),Double.valueOf(pr[i].getText()).doubleValue());							
						}
					}
					if (ok==1)
					{
						//creo l'oggetto di tipo Priorita' e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						Priorita p=new Priorita();
						//0 corrisponde alla scelta di PRIORITA' non preemptive
						sta=p.schedulaPriorita(proc,np,0);						
						for(int i=0;i<np;i++)
						{				
							/*
								salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
								presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
								alle prime 2 cifre decimali. Poi con setText() li scrivo nelle caselle di testo
								in finestra risultati
							*/
							app=sta.getAttesa(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tat[i].setText(String.valueOf(app));
							app=sta.getRisposta(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trisp[i].setText(String.valueOf(app));
							app=sta.getAround(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turn[i].setText(String.valueOf(app));							
							part[i]=sta.getPartenza(i);
							fine[i]=sta.getFine(i);							
						}
						/*
							come prima, ma ora prendo i tempi medi (con 3 cifre dopo la virgola)
						*/
						app=sta.getAttesam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						tatm.setText(String.valueOf(app));
						app=sta.getRispostam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						trispm.setText(String.valueOf(app));
						app=sta.getAroundm();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						turnm.setText(String.valueOf(app));
						/*
							moltiplico i valori di partenza e di fine per l'intervallo
							i valori di part vengono salvati in temp perche' altrimenti nel metodo paint
							avrei dovuto ridividerlo ancora e c'erano problemi di perdita di precisione
						*/
						for(int i=0;i<np;i++)
						{
							temp[i]=part[i]*intervallo;
							fine[i]=fine[i]*intervallo;
						}
						//aggiorno il grafico
						gb.update(grafico);
					}
				}
				break;
				case 4:
				{
					/*
							PRIORITA' preemptive
					*/
					for(int i=0;i<np;i++)
					{	
						/*
						rieseguo il controllo fatto in precedenza ma aggiungendo anche i campi
						relativi alla priorita'
						*/
						if ((ta[i].getText().equals(""))||(tc[i].getText().equals(""))||(pr[i].getText().equals("")))
						{
							if(ta[i].getText().equals(""))
								ta[i].setBackground(Color.red);
							if(tc[i].getText().equals(""))
								tc[i].setBackground(Color.red);
							//se la casella di testo priorita' e' vuota metto il colore rosso alla casella 
							//di testo corrispondente
							if(pr[i].getText().equals(""))
								pr[i].setBackground(Color.red);
							f.setVisible(false);
							f1.setVisible(true);
							f2.setVisible(false);
							f3.setVisible(false);
							/*
								se almeno un campo e' vuoto pongo ok a 2.
								metto 2 invece di 0 come prima per differenziare i due casi.
							*/
							ok=2;
						}
						//se ok rimane invariato		
						else if (ok==1)
						{
							//ripristino il colore verde
							ta[i].setBackground(col);
							tc[i].setBackground(col);
							pr[i].setBackground(col);
							//creo gli oggetti di tipo Processo
							proc[i]=new Processo(Double.valueOf(ta[i].getText()).doubleValue(),Double.valueOf(tc[i].getText()).doubleValue(),Double.valueOf(pr[i].getText()).doubleValue());								
						}
					}					
					if (ok==1)
					{
						//setto il tipo=1 (disegno preemptive)
						tipo=1;
						//creo l'oggetto di tipo Priorita' e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						Priorita p=new Priorita();
						//1 corrisponde alla scelta di Priorita' preemptive
						sta=p.schedulaPriorita(proc,np,1);
						for(int i=0;i<np;i++)
						{
							/*
								salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
								presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
								alla prima cifra decimale. Poi con setText() li scrivo nelle caselle di testo
								in finestra risultati
							*/				
							app=sta.getAttesa(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tat[i].setText(String.valueOf(app));
							app=sta.getRisposta(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trisp[i].setText(String.valueOf(app));
							app=sta.getAround(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turn[i].setText(String.valueOf(app));
						}
						/*
							come prima, ma ora prendo i tempi medi (con 2 cifre dopo la virgola)
						*/
						app=sta.getAttesam();
						bg=new BigDecimal(app);
						bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						tatm.setText(String.valueOf(app));
						app=sta.getRispostam();
						bg=new BigDecimal(app);
						bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						trispm.setText(String.valueOf(app));
						app=sta.getAroundm();
						bg=new BigDecimal(app);
						bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						turnm.setText(String.valueOf(app));
						//divido l'intervallo per 10
						intervallo=intervallo/10;
						//prendo dall'oggetto stat il vettore esecuzione	
						for(double i=0;i<(int)(tempo*10);i++)	
							esecuzione[(int)i]=sta.getEsecuzione((int)i);
						//aggiorno il grafico
						gb.update(grafico);
					}
				}
				break;
				case 5:
				{
					/*
							HRRN non preemptive
					*/
					//se i campi sono stati tutti riempiti
					if (ok==1)
					{
						Hrrn f=new Hrrn();
						//setto il tipo=0 (disegno non preemptive)
						tipo=0;
						//creo l'oggetto di tipo Hrrn e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						sta=f.schedulaHrrn(proc,np);
						for(int i=0;i<np;i++)
						{				
							/*
								salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
								presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
								alle prime 2 cifre decimali. Poi con setText() li scrivo nelle caselle di testo
								in finestra risultati
							*/
							app=sta.getAttesa(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tat[i].setText(String.valueOf(app));
							app=sta.getRisposta(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trisp[i].setText(String.valueOf(app));
							app=sta.getAround(i);
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turn[i].setText(String.valueOf(app));							
							part[i]=sta.getPartenza(i);
							fine[i]=sta.getFine(i);
						}
						/*
							come prima, ma ora prendo i tempi medi (con 3 cifre dopo la virgola)
						*/
						app=sta.getAttesam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						tatm.setText(String.valueOf(app));
						app=sta.getRispostam();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						trispm.setText(String.valueOf(app));
						app=sta.getAroundm();
						bg=new BigDecimal(app);
						bg = bg.setScale(3, BigDecimal.ROUND_HALF_UP);
						app=bg.doubleValue();
						turnm.setText(String.valueOf(app));
						/*
							moltiplico i valori di partenza e di fine per l'intervallo
							i valori di part vengono salvati in temp perche' altrimenti nel metodo paint
							avrei dovuto ridividerlo ancora e c'erano problemi di perdita di precisione
						*/
						for(int i=0;i<np;i++)
						{
							temp[i]=part[i]*intervallo;
							fine[i]=fine[i]*intervallo;
						}
						//aggiorno il grafico
						gb.update(grafico);
					}
				}
				break;
				case 6:
				{
					/*
							ROUND ROBIN modalita' attesa
					*/
					if (ok==1)
					{
						//setto il tipo=1 (disegno preemptive)
						tipo=1;
						//creo l'oggetto di tipo RoundRobin e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						RoundRobin r=new RoundRobin();
						//se la casella di testo del quanto e' vuota
						if (quanto.getText().equals(""))
						{
							//coloro la casella di rosso
							quanto.setBackground(Color.red);
							f.setVisible(false);
							f1.setVisible(true);
							f2.setVisible(false);
							f3.setVisible(false);
						}
						else
						{
							//prendo il valore del quanto e ripristino il colore verde
							q=Double.valueOf(quanto.getText()).doubleValue();
							quanto.setBackground(col);
							//1 corrisponde alla scelta di Round Robin attesa
							sta=r.schedulaRoundRobin(proc,np,q,1);
							for(int i=0;i<np;i++)
							{				
								/*
									salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
									presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
									alla prima cifra decimale. Poi con setText() li scrivo nelle caselle di testo
									in finestra risultati
								*/
								app=sta.getAttesa(i);
								bg=new BigDecimal(app);
								bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
								app=bg.doubleValue();
								tat[i].setText(String.valueOf(app));
								app=sta.getRisposta(i);
								bg=new BigDecimal(app);
								bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
								app=bg.doubleValue();
								trisp[i].setText(String.valueOf(app));
								app=sta.getAround(i);
								bg=new BigDecimal(app);
								bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
								app=bg.doubleValue();
								turn[i].setText(String.valueOf(app));
							}
							/*
								come prima, ma ora prendo i tempi medi (con 2 cifre dopo la virgola)
							*/
							app=sta.getAttesam();
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tatm.setText(String.valueOf(app));
							app=sta.getRispostam();
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trispm.setText(String.valueOf(app));
							app=sta.getAroundm();
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turnm.setText(String.valueOf(app));
							//divido l'intervallo per 10
							intervallo=intervallo/10;
							//salvo il vettore esecuzione
							for(double i=0;i<(int)(tempo*10);i++)	
								esecuzione[(int)i]=sta.getEsecuzione((int)i);
							//aggiorno il grafico
							gb.update(grafico);
						}
					}
				}
				break;
				case 7:
				{
					/*
							ROUND ROBIN modalita' risposta
					*/
					if (ok==1)
					{
						//setto il tipo=1 (disegno preemptive)
						tipo=1;
						//creo l'oggetto di tipo RoundRobin e chiamo il metodo per lo scheduling salvando l'oggetto
						//di tipo stat
						RoundRobin r=new RoundRobin();
						//se la casella di testo del quanto e' vuota
						if (quanto.getText().equals(""))
						{
							//coloro la casella di rosso
							quanto.setBackground(Color.red);
							f.setVisible(false);
							f1.setVisible(true);
							f2.setVisible(false);
							f3.setVisible(false);
						}
						else
						{
							//prendo il valore del quanto e ripristino il colore verde
							q=Double.valueOf(quanto.getText()).doubleValue();
							quanto.setBackground(col);
							//0 corrisponde alla scelta di Round Robin risposta
							sta=r.schedulaRoundRobin(proc,np,q,0);
							for(int i=0;i<np;i++)
							{		
								/*
									salvo in una variabile temporanea i valori (tempo di attesa, risposta, turnaround) 
									presi dall'oggetto di tipo stat e li arrotondo con BigDecimal, in questo caso
									alla prima cifra decimale. Poi con setText() li scrivo nelle caselle di testo
									in finestra risultati
								*/		
								app=sta.getAttesa(i);
								bg=new BigDecimal(app);
								bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
								app=bg.doubleValue();
								tat[i].setText(String.valueOf(app));
								app=sta.getRisposta(i);
								bg=new BigDecimal(app);
								bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
								app=bg.doubleValue();
								trisp[i].setText(String.valueOf(app));
								app=sta.getAround(i);
								bg=new BigDecimal(app);
								bg = bg.setScale(1, BigDecimal.ROUND_HALF_UP);
								app=bg.doubleValue();
								turn[i].setText(String.valueOf(app));
							}
							/*
								come prima, ma ora prendo i tempi medi (con 2 cifre dopo la virgola)
							*/
							app=sta.getAttesam();
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							tatm.setText(String.valueOf(app));
							app=sta.getRispostam();
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							trispm.setText(String.valueOf(app));
							app=sta.getAroundm();
							bg=new BigDecimal(app);
							bg = bg.setScale(2, BigDecimal.ROUND_HALF_UP);
							app=bg.doubleValue();
							turnm.setText(String.valueOf(app));
							//divido l'intervallo per 10
							intervallo=intervallo/10;
							//salvo il vettore esecuzione
							for(double i=0;i<(int)(tempo*10);i++)
								esecuzione[(int)i]=sta.getEsecuzione((int)i);	
							//aggiorno il grafico
							gb.update(grafico);
						}
					}
				}
				break;
			}
		}
	}	
}
