/*
Alban Francesco

Questa classe implementa l'algoritmo di scheduling HRRN non preemptive
*/
package classFile;
public class Hrrn
	{
		//costruttore vuoto
		public Hrrn(){}
		/*
			metodo per trovare quale processo mandare in esecuzione.
			Controlla i processi arrivati al tempo tar con tempo di computazione >0 e manda
			in esecuzione il processo con priorita' piu' alta (in questo caso priorita' alta
			corrisponde al numero piu' alto).		
		*/
		public static int trovaMin(Processo[] p,int n,double tar,double[] attesa)
		{
			int min=10000;
			double priorita=-100000;
			//vettore delle priorita' dei processi
			double []pr=new double[n];
			for(int i=0;i<n;i++)
			{					
					if ((p[i].getTa()<=tar)&&(p[i].getTc()>0))
					{
						//calcolo la priorita' secondo la formula di HRRN
						pr[i]=(1.0+(attesa[i]/p[i].getTc()));
						if (pr[i]>priorita)
						{
							priorita=pr[i];
							min=i;
						}
					}			
			}			
			return min;
		}
		public stat schedulaHrrn(Processo[] p,int n)
		{		
			double tempo=0;
			//dichiaro e inizializzo il vettore attesa
			double []attesa=new double[n];
			
			for(int i=0;i<n;i++)
				attesa[i]=0.0;
			//calcolo il tempo
			for(int i=0;i<n;i++)
				tempo+=p[i].getTc();
			int min;
			//trovo il processo da mandare in esecuzione al tempo 0
			min=trovaMin(p,n,0,attesa);
			double i=0;
			//dichiaro e inizializzo i vettori partenza e fine
			double []fine=new double[n];
			double []partenza=new double[n];
			for(int o=0;o<n;o++)
			{
				fine[o]=0;
				partenza[o]=-1;		
			}
			while (i<tempo)
			{					
				//salvo il tempo di partenza di ogni processo
				if (partenza[min]==-1)
					partenza[min]=i;
				double app=p[min].getTc();	
				//incremento i del valore pari al tempo di computazione del processo appena eseguito								
				i=i+app;															
				p[min].setTc(p[min].getTc()-app);	
				//salvo il tempo di fine di ogni processo												
				fine[min]=i;
				//dopo l'esecuzione di ogni processo aggiorno il tempo di attesa di tutti gli altri
				for(int j=0;j<n;j++)
				{
					if ((p[j].getTc()>0)&&(p[j].getTa()<=i))
					{
						attesa[j]=i-p[j].getTa();
					}
				}
				//trovo il nuovo processo da mandare in esecuzione al tempo i con i tempi di attesa aggiornati
				min=trovaMin(p,n,i,attesa);				
			}
			for(int j=0;j<n;j++)
			{													
				attesa[j]=fine[j]-p[j].getTcIniz()-p[j].getTa();												
			}
			/*
				Creo un oggetto di tipo calcolo per calcolare le statistiche e salvo un oggetto di tipo stat
				che contiene tutti questi valori
			*/					
			Calcolo c=new Calcolo(partenza,fine,n);
			stat sta=c.calcola(attesa,p);
			return sta;
		}
}
