/*
Alban Francesco

Questa classe implementa l'algoritmo di scheduling a Priorita' sia non preemptive che preemptive

*/
package classFile;
public class Priorita
	{
		//costruttore vuoto
		public Priorita(){}
		/*
			metodo per trovare quale processo mandare in esecuzione.
			Controlla i processi arrivati al tempo tar con tempo di computazione >0 e manda
			in esecuzione il processo con priorita' piu' alta (in questo caso priorita' alta
			corrisponde al numero piu' basso).		
		*/
		public static int trovaMin(Processo[] p,int n,double tar,double []fine)
		{
			double priorita=100000;
			int min=10000000;			
			for(int i=0;i<n;i++)
			{					
				if ((p[i].getTa()<=tar)&&(p[i].getTc()>0)&&(p[i].getP()<priorita)&&(fine[i]==-1))
				{
					priorita=p[i].getP();
					min=i;
				}			
			}
			return min;
		}
		public stat schedulaPriorita(Processo[] p,int n,int scelta)
		{		
			double tempo=0;
			//dichiaro un oggetto di tipo Calcolo e di tipo stat per poterli utilizzare in seguito
			Calcolo c;
			//deve essere forzatamente inizializzato a null perche' questo e' l'oggetto per il return
			stat sta=null;
			//dichiaro e inizializzo il vettore attesa
			double []attesa=new double[n];
			for(int i=0;i<n;i++)
				attesa[i]=0.0;
			//calcolo il tempo	
			for(int i=0;i<n;i++)
				tempo+=p[i].getTc();
			int min;
			//dichiaro e inizializzo i vettori partenza e fine
			double []fine=new double[n];
			double []partenza=new double[n];
			for(int o=0;o<n;o++)
			{
				fine[o]=-1;
				partenza[o]=-1;		
			}			
			if (scelta==0)			
			{	
				//algoritmo non-preemptive
				double i=0;
				//trovo il processo da mandare in esecuzione al tempo 0
				min=trovaMin(p,n,0,fine);				
				while (i<tempo)
				{	
					//salvo il tempo di partenza di ogni processo					
					if (partenza[min]==-1)
						partenza[min]=i;
					double app=p[min].getTc();
					//incremento i del valore pari al tempo di computazione del processo appena eseguito
					i=i+app;
					p[min].setTc(p[min].getTc()-app);
					//salvo il tempo di fine di ogni processo		
					fine[min]=i;
					//trovo il nuovo processo da mandare in esecuzione al tempo i
					min=trovaMin(p,n,i,fine);
				}
				for(int j=0;j<n;j++)
				{
					//calcolo i valori del tempo di attesa per ogni processo
					attesa[j]=fine[j]-p[j].getTcIniz()-p[j].getTa();
				}
				/*
					Creo un oggetto di tipo calcolo per calcolare le statistiche e salvo un oggetto di tipo stat
					che contiene tutti questi valori
				*/		
				c=new Calcolo(partenza,fine,n);
				sta=c.calcola(attesa,p);			
			}
			else if (scelta==1)
			{
				//algoritmo preemptive
				
				/*
					Per l'implementazione di questo algoritmo (e di tutti gli algoritmi preemptive) 
					ho dovuto moltiplicare tutti i valori per 10 per poi mandare in esecuzione 
					il processo per un tempo. Cosi' corrisponde a un tempo pari a 0.1. 
					Ho dovuto fare questo perche' tenendo i valori iniziali e togliendo 0.1 dopo qualche passaggio
					i valori si "sporcavano" diventando ad esempio 0.10000000001 cosi' che non arrivavano mai a zero
					dandomi errori in esecuzione
				*/
				//moltiplico tutti i valori per 10
				for(int i=0;i<n;i++)
				{
					p[i].setTc(p[i].getTc()*10);
					p[i].setTa(p[i].getTa()*10);					
				}
				tempo=tempo*10;
				/*
					dichiaro e inizializzo il vettore esecuzione. Questo serve per salvare ad ogni passo quale
					processo viene mandato in esecuzione.
					Nella creazione del vettore viene fatto un casting alla variabile tempo. 
					Limitando i valori di tutti i processi al decimo e moltiplicando il tempo per 10 non 
					si ha nessun arrotondamento.
				*/
				double []esecuzione=new double[(int)tempo];
				for(int i=0;i<tempo;i++)
					esecuzione[i]=-1;
				//algoritmo preemptive				
				for(double i=0;i<tempo;i++)
				{					
					//ad ogni ciclo trovo il processo da mandare in esecuzione
					min=trovaMin(p,n,i,fine);
					for(int j=0;j<n;j++)
					{
						//se il processo j non deve andare in esecuzione (!=min) e ha ancora tempo di computazione
						//incremento il suo tempo di attesa
						if ((min!=j)&&(p[j].getTa()<=i)&&(p[j].getTc()>0))
							attesa[j]++;
					}				
					if (p[min].getTc()>0)
					{
						//salvo il tempo di partenza di ogni processo	(ovviamente lo divido per 10)
						if (partenza[min]==-1)
							partenza[min]=i/10;
						//assegno al vettore esecuzione nella posizione i (corrispondente al tempo) il numero del processo
						//andato in esecuzione (min)
						esecuzione[(int)i]=min;						
						p[min].setTc(p[min].getTc()-1);						
					}
					if (p[min].getTc()==0)
					{						
						//salvo il tempo di fine di ogni processo	(ovviamente lo divido per 10)
						fine[min]=i/10;						
					}					
				}
				for(int j=0;j<n;j++)
				{
					//divido il tempo di attesa di ogni processo per 10
					//divido anche il tempo di arrivo perche' questo valore serve nella classe calcolo 
					//per il calcolo delle statistiche
					attesa[j]=attesa[j]/10;
					p[j].setTa(p[j].getTa()/10);	
				}
				/*
					Creo un oggetto di tipo calcolo per calcolare le statistiche e salvo un oggetto di tipo stat
					che contiene tutti questi valori
				*/	
				c=new Calcolo(partenza,fine,n);
				sta=c.calcola(attesa,p,esecuzione);
			}						
			return sta;
		}
}
