/*
Alban Francesco

Questa classe implementa l'algoritmo di scheduling Round Robin risposta e attesa
*/
package classFile;
public class RoundRobin
	{
		//costruttore vuoto
		public RoundRobin(){}
		/*
			metodo per trovare quale processo mandare in esecuzione.
			Controlla i processi arrivati al tempo tar con tempo di computazione >0.
			Inserisce in coda tutti i processi arrivati ad un determinato tempo i solamente
			se non sono gia' presenti in coda.
		*/
		public static int trovaMin(Processo[] p,int n,double tar,Coda c,int[] presente)		
		{
			int min=10000;
			for(int i=0;i<n;i++)
			{
					if ((p[i].getTa()==tar)&&(p[i].getTc()>0))
					{
						if(presente[i]==0)
						{
								//inserisco in coda il processo i
								c.enqueue(c,i);
								//pongo il flag di presente a 1
								presente[i]=1;
						}
					}
			}
			//prendo il primo elemento della coda
			min=c.top(c);
			//lo elimino dalla coda
			c.dequeue(c);
			return min;
		}
		public stat schedulaRoundRobin(Processo[] p,int n,double q,int scelta)
		{		
			double tempo=0;
			//dichiaro e inizializzo il vettore attesa
			double []attesa=new double[n];
			for(int i=0;i<n;i++)
				attesa[i]=0.0;		
			//calcolo il tempo
			for(int i=0;i<n;i++)
				tempo+=p[i].getTc();
			//moltiplico il tempo per 10		
			tempo=tempo*10;
			/*
					dichiaro e inizializzo il vettore esecuzione. Questo serve per salvare ad ogni passo quale
					processo viene mandato in esecuzione.
					Nella creazione del vettore viene fatto un casting alla variabile tempo. 
					Limitando i valori di tutti i processi al decimo e moltiplicando il tempo per 10 non 
					si ha nessun arrotondamento.
			*/			
			double esecuzione[]=new double[(int)tempo];			
			//moltiplico il quando per 10 e setto questo valore per tutti i processi
			q=q*10;	
			for(int i=0;i<n;i++)			
				p[i].setQuanto(q);
			//dichiaro e inizializzo i vettori di fine, partenza e presente			
			double []fine=new double[n];
			double []partenza=new double[n];
			int []presente=new int[n];
			for(int o=0;o<n;o++)
			{
				fine[o]=0;
				partenza[o]=-1;	
				presente[o]=0;
				//moltiplico per 10 il tempo di computazione e di arrivo di tutti i processi
				p[o].setTc(p[o].getTc()*10);
				p[o].setTa(p[o].getTa()*10);
			}
			//creo la coda		
			Coda c=new Coda(n*100+2);		
			int min;	
			//trovo l'elemento da mandare in esecuzione al tempo 0
			//si noti che e' sempre lo stesso sia per la modalita' rr risposta e attesa
			min=trovaMin(p,n,0,c,presente);			
			for(double i=0;i<tempo;i++)
			{									
				if (scelta==1)
				{
					//round robin attesa
					for(int j=0;j<n;j++)
					{
						if ((min!=j)&&(p[j].getTc()>0)&&(p[j].getTa()<=i))
						{													
							//se il processo j non deve andare in esecuzione (!=min) e ha ancora tempo di computazione
							//incremento il suo tempo di attesa
							attesa[j]++;
							//se il processo j e' arrivato esattamente al tempo i e non e' gia' presente in coda
							//lo metto in cosa e pongo presente a 1
							if (p[j].getTa()==i)
							{
								if(presente[j]==0)
								{										
									c.enqueue(c,j);
									presente[j]=1;
								}
							}
						}
					}
					//se il processo ha ancora tempo di computazione e quanto lo eseguo
					if ((p[min].getTc()>0)&&(p[min].getQuanto()>0))
					{						
						//salvo il tempo di partenza di ogni processo	(ovviamente lo divido per 10)
						if (partenza[min]==-1)
								partenza[min]=i/10;
						//sottraggo 1 al tempo di computazione e al quanto
						p[min].setTc(p[min].getTc()-1);
						p[min].setQuanto(p[min].getQuanto()-1);
						//assegno al vettore esecuzione nella posizione i (corrispondente al tempo) il numero del processo
						//andato in esecuzione (min)
						esecuzione[(int)i]=min;
						
					}
					//se il processo ha finito il quanto ma non ha finito il tempo di computazione
					if ((p[min].getTc()>0)&&(p[min].getQuanto()==0))
					{
						int temp=min;
						//riassegno il quanto al processo
						p[temp].setQuanto(q);
						//lo rimetto in coda
						c.enqueue(c,min);
						//prendo il primo elemento della coda e lo elimino
						//non controllo se la coda vuota perche' ovviamente ha almeno un elemento
						min=c.top(c);
						c.dequeue(c);
					}
					if (p[min].getTc()==0)
					{
						//salvo il tempo di fine di ogni processo	(ovviamente lo divido per 10)
						fine[min]=i;
						//se la coda non e' vuota
						if (!(c.codavuota(c)))
						{
							//prendo il primo elemento della coda e lo elimino
							min=c.top(c);
							c.dequeue(c);							
						}
						//se la coda e' vuota
						else
						{
							//cerco un nuovo elemento chiamando la procedura trovaMin
							if (i<tempo)
								min=trovaMin(p,n,i+1,c,presente);								
							else
								min=0;
						}
						
					}				
				}			
				if (scelta==0)
				{				
					//round robin risposta		
					for(int j=0;j<n;j++)
					{
						if ((min!=j)&&(p[j].getTc()>0)&&(p[j].getTa()<=i))
						{														
							//se il processo j e' arrivato esattamente al tempo i e non e' gia' presente in coda
							//lo metto in cosa e pongo presente a 1
							if (p[j].getTa()==i)							
							{	
								if(presente[j]==0)	
								{										
									c.enqueue(c,j);
									presente[j]=1;
								}								
							}
						}
					}
					//se il processo ha finito il quanto ma non il tempo di computazione
					if ((p[min].getTc()>0)&&(p[min].getQuanto()==0))
					{						
						//creo una variabile temporanea e salvo il numero del processo appena andato in esecuzione
						int temp=min;
						//riassegno il quanto al processo appena eseguito
						p[temp].setQuanto(q);
						//se la coda non e' vuota
						if (!(c.codavuota(c)))
						{
							//estraggo dalla coda il primo elemento e lo tolgo dalla coda
							min=c.top(c);							
							c.dequeue(c);
							//reinserisco in coda il processo eseguito al tempo precedente
							c.enqueue(c,temp);
						}
						//se la coda e' vuota
						else
						{							
							//chiamo la procedura per trovare il processo da mandare in esecuzione
							min=trovaMin(p,n,i,c,presente);
							//reinserisco in coda il processo eseguito al tempo precedente
							c.enqueue(c,temp);
							if (min==-1)
							{	
								//se ritorna -1 significa che non ho trovato nessun nuovo processo
								//ma prima ho reinserito in coda un processo quindi posso estrarre dalla coda
								min=c.top(c);
								c.dequeue(c);								
							}
						}
					}					
					for(int j=0;j<n;j++)
					{
						if ((min!=j)&&(p[j].getTc()>0)&&(p[j].getTa()<=i))
						{													
							//se il processo j non deve andare in esecuzione (!=min) e ha ancora tempo di computazione
							//incremento il suo tempo di attesa
							attesa[j]++;
						}
					}
					//se il processo ha ancora tempo di computazione e quanto lo eseguo
					if ((p[min].getTc()>0)&&(p[min].getQuanto()>0))
					{
						//setto il tempo di partenza
						if (partenza[min]==-1)
								partenza[min]=i/10;
						//diminuisco il tempo di computazione e il quanto del processo
						p[min].setTc(p[min].getTc()-1);
						p[min].setQuanto(p[min].getQuanto()-1);
						//assegno al vettore esecuzione nella posizione i (corrispondente al tempo) il numero del processo
						//andato in esecuzione (min)
						esecuzione[(int)i]=min;
						
					}					
					//se il processo ha finito il tempo di computazione							
					if (p[min].getTc()==0)
					{
						//assegno il valore di fine
						fine[min]=i;
						//p[min].setTc(0);						
						//se la coda non e' vuota
						if (!(c.codavuota(c)))
						{
							//prendo il primo elemento dalla coda e lo estraggo
							min=c.top(c);							
							c.dequeue(c);							
						}
						//se la coda e' vuota
						else
						{								
							//chiamo la procedura per trovare il processo da mandare in esecuzione
							min=trovaMin(p,n,i+1,c,presente);
						}
					}										
				}
			}
			for(int j=0;j<n;j++)
			{				
				//divido i valori di attesa, fine e tempo di arrivo per 10
				attesa[j]=attesa[j]/10;
				fine[j]=fine[j]/10;
				p[j].setTa(p[j].getTa()/10);										
			}			
			/*
				Creo un oggetto di tipo calcolo per calcolare le statistiche e salvo un oggetto di tipo stat
				che contiene tutti questi valori
			*/		
			Calcolo cal=new Calcolo(partenza,fine,n);
			stat sta=cal.calcola(attesa,p,esecuzione);
			return sta;
		}
}
